!**************************************************************
!* AceGen    7.402 Linux (2 Jan 22)                           *
!*           Co. J. Korelc  2020           24 Oct 23 11:39:39 *
!**************************************************************
! User     : Full professional version
! Notebook : elmt05_ecm_semi _implicit _theta
! Evaluation time                 : 8 s     Mode  : Optimal
! Number of formulae              : 227     Method: Automatic
! Subroutine                      : elmt05_ecm_semi_implicit_theta size: 4269
! Total size of Mathematica  code : 4269 subexpressions
! Total size of Fortran code      : 12193 bytes

!******************* S U B R O U T I N E **********************
      SUBROUTINE elmt05_ecm_semi_implicit_theta(activator,coupling
     &,thetanumerical,dt,Xn,Un,xi,eta,zeta,cPvec,cPprevvec,kP,cEvec
     &,cEprevvec,etaE,epsilonE,cEeq,cEtf,kE,rhoSvec,rhoSprevvec,kS
     &,resE,tangEU,tangEP,tangEE,tangES)
      IMPLICIT NONE
      include 'sms.h'
      INTEGER activator,coupling
      DOUBLE PRECISION v(476),thetanumerical,dt,Xn(8,3),Un
     &(8,3),xi,eta,zeta,cPvec(8),cPprevvec(8),kP,cEvec(8),cEprevvec(8
     &),etaE,epsilonE,cEeq,cEtf,kE,rhoSvec(8),rhoSprevvec(8),kS,resE
     &(8),tangEU(8,24),tangEP(8,8),tangEE(8,8),tangES(8,8)
      v(2)=thetanumerical
      v(300)=1d0-v(2)
      v(4)=dt
      v(5)=Xn(1,1)
      v(6)=Xn(1,2)
      v(7)=Xn(1,3)
      v(8)=Xn(2,1)
      v(9)=Xn(2,2)
      v(10)=Xn(2,3)
      v(11)=Xn(3,1)
      v(12)=Xn(3,2)
      v(13)=Xn(3,3)
      v(14)=Xn(4,1)
      v(15)=Xn(4,2)
      v(16)=Xn(4,3)
      v(17)=Xn(5,1)
      v(18)=Xn(5,2)
      v(19)=Xn(5,3)
      v(20)=Xn(6,1)
      v(21)=Xn(6,2)
      v(22)=Xn(6,3)
      v(23)=Xn(7,1)
      v(24)=Xn(7,2)
      v(25)=Xn(7,3)
      v(26)=Xn(8,1)
      v(27)=Xn(8,2)
      v(28)=Xn(8,3)
      v(29)=Un(1,1)
      v(30)=Un(1,2)
      v(31)=Un(1,3)
      v(32)=Un(2,1)
      v(33)=Un(2,2)
      v(34)=Un(2,3)
      v(35)=Un(3,1)
      v(36)=Un(3,2)
      v(37)=Un(3,3)
      v(38)=Un(4,1)
      v(39)=Un(4,2)
      v(40)=Un(4,3)
      v(41)=Un(5,1)
      v(42)=Un(5,2)
      v(43)=Un(5,3)
      v(44)=Un(6,1)
      v(45)=Un(6,2)
      v(46)=Un(6,3)
      v(47)=Un(7,1)
      v(48)=Un(7,2)
      v(49)=Un(7,3)
      v(50)=Un(8,1)
      v(51)=Un(8,2)
      v(52)=Un(8,3)
      v(53)=xi
      v(118)=1d0-v(53)
      v(114)=1d0+v(53)
      v(54)=eta
      v(124)=1d0+v(54)
      v(157)=v(124)/8d0
      v(165)=-(v(118)*v(157))
      v(164)=-(v(114)*v(157))
      v(120)=1d0-v(54)
      v(158)=v(120)/8d0
      v(163)=-(v(114)*v(158))
      v(161)=-(v(118)*v(158))
      v(176)=v(163)*(v(10)-v(22))+v(164)*(v(13)-v(25))+v(165)*(v(16)
     &-v(28))+v(161)*(-v(19)+v(7))
      v(173)=v(164)*(v(12)-v(24))+v(165)*(v(15)-v(27))+v(161)*(-v(18)
     &+v(6))+v(163)*(-v(21)+v(9))
      v(170)=v(164)*(v(11)-v(23))+v(165)*(v(14)-v(26))+v(161)*(-v(17)
     &+v(5))+v(163)*(-v(20)+v(8))
      v(55)=zeta
      v(156)=(1d0+v(55))/8d0
      v(167)=-(v(114)*v(156))
      v(166)=-(v(118)*v(156))
      v(127)=v(124)*v(156)
      v(122)=v(120)*v(156)
      v(159)=(1d0-v(55))/8d0
      v(162)=-(v(114)*v(159))
      v(160)=-(v(118)*v(159))
      v(175)=(v(10)-v(13))*v(162)+v(167)*(v(22)-v(25))+v(166)*(v(19)
     &-v(28))+v(160)*(-v(16)+v(7))
      v(172)=v(167)*(v(21)-v(24))+v(166)*(v(18)-v(27))+v(160)*(-v(15)
     &+v(6))+v(162)*(-v(12)+v(9))
      v(194)=-(v(173)*v(175))+v(172)*v(176)
      v(169)=v(167)*(v(20)-v(23))+v(166)*(v(17)-v(26))+v(160)*(-v(14)
     &+v(5))+v(162)*(-v(11)+v(8))
      v(117)=v(124)*v(159)
      v(112)=v(120)*v(159)
      v(174)=v(117)*(v(13)-v(16))+v(122)*(-v(19)+v(22))+v(127)*(v(25)
     &-v(28))+v(112)*(v(10)-v(7))
      v(171)=v(117)*(v(12)-v(15))+v(122)*(-v(18)+v(21))+v(127)*(v(24)
     &-v(27))+v(112)*(-v(6)+v(9))
      v(202)=-(v(172)*v(174))+v(171)*v(175)
      v(198)=-(v(173)*v(174))+v(171)*v(176)
      v(168)=v(117)*(v(11)-v(14))+v(122)*(-v(17)+v(20))+v(127)*(v(23)
     &-v(26))+v(112)*(-v(5)+v(8))
      v(76)=kE
      v(111)=v(112)*v(118)
      v(113)=v(112)*v(114)
      v(334)=(v(113)*v(113))
      v(116)=v(114)*v(117)
      v(339)=(v(116)*v(116))
      v(119)=v(117)*v(118)
      v(344)=(v(119)*v(119))
      v(121)=v(118)*v(122)
      v(347)=(v(121)*v(121))
      v(123)=v(114)*v(122)
      v(352)=(v(123)*v(123))
      v(126)=v(114)*v(127)
      v(355)=(v(126)*v(126))
      v(128)=v(118)*v(127)
      v(358)=(v(128)*v(128))
      v(177)=v(168)*v(194)-v(169)*v(198)+v(170)*v(202)
      v(195)=-(v(194)/v(177))
      v(260)=-(v(127)*v(195))
      v(251)=v(122)*v(195)
      v(242)=-(v(117)*v(195))
      v(233)=v(112)*v(195)
      v(196)=(-(v(170)*v(175))+v(169)*v(176))/v(177)
      v(262)=-(v(127)*v(196))
      v(253)=v(122)*v(196)
      v(244)=-(v(117)*v(196))
      v(235)=v(112)*v(196)
      v(197)=(v(170)*v(172)-v(169)*v(173))/v(177)
      v(264)=-(v(127)*v(197))
      v(255)=v(122)*v(197)
      v(246)=-(v(117)*v(197))
      v(237)=v(112)*v(197)
      v(199)=-(v(198)/v(177))
      v(221)=v(159)*v(199)
      v(209)=v(156)*v(199)
      v(200)=(-(v(170)*v(174))+v(168)*v(176))/v(177)
      v(224)=v(159)*v(200)
      v(211)=v(156)*v(200)
      v(201)=(v(170)*v(171)-v(168)*v(173))/v(177)
      v(227)=v(159)*v(201)
      v(213)=v(156)*v(201)
      v(203)=v(202)/v(177)
      v(222)=v(158)*v(203)
      v(215)=v(157)*v(203)
      v(204)=(v(169)*v(174)-v(168)*v(175))/v(177)
      v(225)=v(158)*v(204)
      v(217)=v(157)*v(204)
      v(205)=(-(v(169)*v(171))+v(168)*v(172))/v(177)
      v(228)=v(158)*v(205)
      v(219)=v(157)*v(205)
      v(206)=v(209)+v(215)
      v(207)=v(211)+v(217)
      v(208)=v(213)+v(219)
      v(210)=-v(209)+v(222)
      v(212)=-v(211)+v(225)
      v(214)=-v(213)+v(228)
      v(216)=-v(215)+v(221)
      v(218)=-v(217)+v(224)
      v(220)=-v(219)+v(227)
      v(223)=-v(221)-v(222)
      v(226)=-v(224)-v(225)
      v(229)=-v(227)-v(228)
      v(230)=v(118)*v(223)+v(233)
      v(231)=v(118)*v(226)+v(235)
      v(232)=v(118)*v(229)+v(237)
      v(234)=v(114)*v(223)-v(233)
      v(236)=v(114)*v(226)-v(235)
      v(238)=v(114)*v(229)-v(237)
      v(239)=v(114)*v(216)+v(242)
      v(240)=v(114)*v(218)+v(244)
      v(241)=v(114)*v(220)+v(246)
      v(243)=v(118)*v(216)-v(242)
      v(245)=v(118)*v(218)-v(244)
      v(247)=v(118)*v(220)-v(246)
      v(248)=v(118)*v(210)+v(251)
      v(249)=v(118)*v(212)+v(253)
      v(250)=v(118)*v(214)+v(255)
      v(252)=v(114)*v(210)-v(251)
      v(254)=v(114)*v(212)-v(253)
      v(256)=v(114)*v(214)-v(255)
      v(257)=v(114)*v(206)+v(260)
      v(258)=v(114)*v(207)+v(262)
      v(259)=v(114)*v(208)+v(264)
      v(261)=v(118)*v(206)-v(260)
      v(263)=v(118)*v(207)-v(262)
      v(265)=v(118)*v(208)-v(264)
      v(278)=v(230)*v(30)+v(234)*v(33)+v(239)*v(36)+v(243)*v(39)+v
     &(248)*v(42)+v(252)*v(45)+v(257)*v(48)+v(261)*v(51)
      v(279)=1d0+v(231)*v(30)+v(236)*v(33)+v(240)*v(36)+v(245)*v(39)
     &+v(249)*v(42)+v(254)*v(45)+v(258)*v(48)+v(263)*v(51)
      v(280)=v(232)*v(30)+v(238)*v(33)+v(241)*v(36)+v(247)*v(39)+v
     &(250)*v(42)+v(256)*v(45)+v(259)*v(48)+v(265)*v(51)
      v(281)=v(230)*v(31)+v(234)*v(34)+v(239)*v(37)+v(243)*v(40)+v
     &(248)*v(43)+v(252)*v(46)+v(257)*v(49)+v(261)*v(52)
      v(282)=v(231)*v(31)+v(236)*v(34)+v(240)*v(37)+v(245)*v(40)+v
     &(249)*v(43)+v(254)*v(46)+v(258)*v(49)+v(263)*v(52)
      v(283)=1d0+v(232)*v(31)+v(238)*v(34)+v(241)*v(37)+v(247)*v(40)
     &+v(250)*v(43)+v(256)*v(46)+v(259)*v(49)+v(265)*v(52)
      v(284)=(-(v(280)*v(282))+v(279)*v(283))*(1d0+v(230)*v(29)+v(234
     &)*v(32)+v(239)*v(35)+v(243)*v(38)+v(248)*v(41)+v(252)*v(44)+v
     &(257)*v(47)+v(261)*v(50))+(v(280)*v(281)-v(278)*v(283))*(v(231
     &)*v(29)+v(236)*v(32)+v(240)*v(35)+v(245)*v(38)+v(249)*v(41)+v
     &(254)*v(44)+v(258)*v(47)+v(263)*v(50))+(-(v(279)*v(281))+v(278
     &)*v(282))*(v(232)*v(29)+v(238)*v(32)+v(241)*v(35)+v(247)*v(38)
     &+v(250)*v(41)+v(256)*v(44)+v(259)*v(47)+v(265)*v(50))
      v(286)=cEvec(1)*v(111)+cEvec(2)*v(113)+cEvec(3)*v(116)+cEvec(4
     &)*v(119)+cEvec(5)*v(121)+cEvec(6)*v(123)+cEvec(7)*v(126)+cEvec
     &(8)*v(128)
      v(296)=(epsilonE*kP*(cPprevvec(1)*v(111)+cPprevvec(2)*v(113)
     &+cPprevvec(3)*v(116)+cPprevvec(4)*v(119)+cPprevvec(5)*v(121)
     &+cPprevvec(6)*v(123)+cPprevvec(7)*v(126)+cPprevvec(8)*v(128))*v
     &(4))/v(284)
      v(289)=cEprevvec(1)*v(111)+cEprevvec(2)*v(113)+cEprevvec(3)*v
     &(116)+cEprevvec(4)*v(119)+cEprevvec(5)*v(121)+cEprevvec(6)*v
     &(123)+cEprevvec(7)*v(126)+cEprevvec(8)*v(128)
      v(295)=v(286)-v(289)
      v(297)=((-1d0)*etaE*kS*(rhoSprevvec(1)*v(111)+rhoSprevvec(2)*v
     &(113)+rhoSprevvec(3)*v(116)+rhoSprevvec(4)*v(119)+rhoSprevvec(5
     &)*v(121)+rhoSprevvec(6)*v(123)+rhoSprevvec(7)*v(126)
     &+rhoSprevvec(8)*v(128))*v(4))/v(76)
      v(363)=1d0*v(297)
      v(291)=v(111)*v(296)
      v(292)=v(111)*v(297)
      v(293)=-(v(76)/(cEeq*cEtf*v(284)))
      v(317)=v(128)*v(293)
      v(333)=v(177)*(v(111)*v(128)+v(2)*(v(128)*v(291)+v(292)*v(317))
     &)
      v(325)=v(317)*v(363)
      v(362)=v(177)*(v(128)+v(2)*(v(128)*v(296)+v(325)))
      v(357)=v(126)*v(362)
      v(351)=v(121)*v(362)
      v(346)=v(119)*v(362)
      v(343)=v(116)*v(362)
      v(316)=v(126)*v(293)
      v(332)=v(177)*(v(111)*v(126)+v(2)*(v(126)*v(291)+v(292)*v(316))
     &)
      v(324)=v(316)*v(363)
      v(364)=v(177)*(v(126)+v(2)*(v(126)*v(296)+v(324)))
      v(354)=v(123)*v(364)
      v(350)=v(121)*v(364)
      v(342)=v(116)*v(364)
      v(338)=v(113)*v(364)
      v(315)=v(123)*v(293)
      v(331)=v(177)*(v(111)*v(123)+v(2)*(v(123)*v(291)+v(292)*v(315))
     &)
      v(323)=1d0*v(315)*v(363)
      v(365)=v(177)*(v(123)+v(2)*(v(123)*v(296)+v(323)))
      v(349)=v(121)*v(365)
      v(337)=v(113)*v(365)
      v(314)=v(121)*v(293)
      v(330)=v(177)*(v(111)*v(121)+v(2)*(v(121)*v(291)+v(292)*v(314))
     &)
      v(313)=v(119)*v(293)
      v(329)=v(177)*(v(111)*v(119)+v(2)*(v(119)*v(291)+v(292)*v(313))
     &)
      v(321)=1d0*v(313)*v(363)
      v(341)=v(116)*v(177)*(v(119)+v(2)*(v(119)*v(296)+v(321)))
      v(312)=v(116)*v(293)
      v(328)=v(177)*(v(111)*v(116)+v(2)*(v(116)*v(291)+v(292)*v(312))
     &)
      v(320)=1d0*v(312)*v(363)
      v(336)=v(113)*v(177)*(v(116)+v(2)*(v(116)*v(296)+v(320)))
      v(311)=v(113)*v(293)
      v(327)=v(177)*(v(111)*v(113)+v(2)*(v(113)*v(291)+v(292)*v(311))
     &)
      v(299)=1d0+v(286)*v(293)
      v(298)=1d0+v(289)*v(293)
      v(366)=v(177)*(v(295)+v(300)*(v(289)*v(296)+1d0*v(298)*v(363))
     &+v(2)*(v(286)*v(296)+1d0*v(299)*v(363)))
      resE(1)=v(177)*(v(111)*v(295)+v(2)*(v(286)*v(291)+v(292)*v(299)
     &)+(v(289)*v(291)+v(292)*v(298))*v(300))
      resE(2)=v(113)*v(366)
      resE(3)=v(116)*v(366)
      resE(4)=v(119)*v(366)
      resE(5)=v(121)*v(366)
      resE(6)=v(123)*v(366)
      resE(7)=v(126)*v(366)
      resE(8)=v(128)*v(366)
      tangEE(1,1)=v(177)*((v(111)*v(111))+v(111)*v(2)*(v(291)+v(292
     &)*v(293)))
      tangEE(1,2)=v(327)
      tangEE(1,3)=v(328)
      tangEE(1,4)=v(329)
      tangEE(1,5)=v(330)
      tangEE(1,6)=v(331)
      tangEE(1,7)=v(332)
      tangEE(1,8)=v(333)
      tangEE(2,1)=v(327)
      tangEE(2,2)=v(177)*(v(334)+v(2)*(v(296)*v(334)+1d0*v(113)*v(311
     &)*v(363)))
      tangEE(2,3)=v(336)
      tangEE(2,4)=v(328)
      tangEE(2,5)=v(331)
      tangEE(2,6)=v(337)
      tangEE(2,7)=v(338)
      tangEE(2,8)=v(332)
      tangEE(3,1)=v(328)
      tangEE(3,2)=v(336)
      tangEE(3,3)=v(177)*(v(339)+v(2)*(v(116)*v(320)+v(296)*v(339)))
      tangEE(3,4)=v(341)
      tangEE(3,5)=v(332)
      tangEE(3,6)=v(338)
      tangEE(3,7)=v(342)
      tangEE(3,8)=v(343)
      tangEE(4,1)=v(329)
      tangEE(4,2)=v(328)
      tangEE(4,3)=v(341)
      tangEE(4,4)=v(177)*(v(344)+v(2)*(1d0*v(119)*v(321)+v(296)*v(344
     &)))
      tangEE(4,5)=v(333)
      tangEE(4,6)=v(332)
      tangEE(4,7)=v(343)
      tangEE(4,8)=v(346)
      tangEE(5,1)=v(330)
      tangEE(5,2)=v(331)
      tangEE(5,3)=v(332)
      tangEE(5,4)=v(333)
      tangEE(5,5)=v(177)*(v(347)+v(2)*(v(296)*v(347)+1d0*v(121)*v(314
     &)*v(363)))
      tangEE(5,6)=v(349)
      tangEE(5,7)=v(350)
      tangEE(5,8)=v(351)
      tangEE(6,1)=v(331)
      tangEE(6,2)=v(337)
      tangEE(6,3)=v(338)
      tangEE(6,4)=v(332)
      tangEE(6,5)=v(349)
      tangEE(6,6)=v(177)*(v(352)+v(2)*(1d0*v(123)*v(323)+v(296)*v(352
     &)))
      tangEE(6,7)=v(354)
      tangEE(6,8)=v(350)
      tangEE(7,1)=v(332)
      tangEE(7,2)=v(338)
      tangEE(7,3)=v(342)
      tangEE(7,4)=v(343)
      tangEE(7,5)=v(350)
      tangEE(7,6)=v(354)
      tangEE(7,7)=v(177)*(v(355)+v(2)*(1d0*v(126)*v(324)+v(296)*v(355
     &)))
      tangEE(7,8)=v(357)
      tangEE(8,1)=v(333)
      tangEE(8,2)=v(332)
      tangEE(8,3)=v(343)
      tangEE(8,4)=v(346)
      tangEE(8,5)=v(351)
      tangEE(8,6)=v(350)
      tangEE(8,7)=v(357)
      tangEE(8,8)=v(177)*(v(358)+v(2)*(1d0*v(128)*v(325)+v(296)*v(358
     &)))
      END
